//+------------------------------------------------------------------+
//|                                                FishingOverTF.mq4 |
//|                                                           PavelG |
//|                                                                  |
//|     600                                      |
//+------------------------------------------------------------------+
#property copyright "PavelG"
#property link      ""

#property indicator_chart_window

extern bool    useind1 = false;//   FishingInd
extern int     i1tf = 0;// 
extern int     otstup1 = 50;//  High Low       
extern int     lineupw1 = 1;//  
extern color   lineupc1 = DodgerBlue;//  
extern int     lineups1 = 1;// 
extern int     linednw1 = 1;//  
extern color   linednc1 = Orange;//  
extern int     linedns1 = 1;// 
extern int     kolshow1 = 50; //      
extern string  tlu1 = "i1TrendlineUp";
extern string  tld1 = "i1TrendlineDn";
//===============================================
extern bool    useind2 = false;//   FishingInd
extern int     i2tf = 0;// 
extern int     otstup2 = 50;//  High Low       
extern int     lineupw2 = 1;//  
extern color   lineupc2 = Turquoise;//  
extern int     lineups2 = 1;// 
extern int     linednw2 = 1;//  
extern color   linednc2 = LightSalmon;//  
extern int     linedns2 = 1;// 
extern int     kolshow2 = 50; //      
extern string  tlu2 = "i2TrendlineUp";
extern string  tld2 = "i2TrendlineDn";
//===============================================
extern bool    useind3 = false;//   FishingZZ
extern int     i3tf = 0;// 
extern int     ExtDepth3=12;
extern int     ExtDeviation3=5;
extern int     ExtBackstep3=3;
extern int     otstup3 = 50;//  High Low       
extern int     lineupw3 = 1;//  
extern color   lineupc3 = Green;//  
extern int     lineups3 = 1;// 
extern int     linednw3 = 1;//  
extern color   linednc3 = MediumVioletRed;//  
extern int     linedns3 = 1;// 
extern bool    showrline3 = false;//   
extern string  tlu3 = "i3TrendlineUp";
extern string  tld3 = "i3TrendlineDn";
//===============================================
extern bool    useind4 = false;//   FishingZZ
extern int     i4tf = 0;// 
extern int     ExtDepth4=12;
extern int     ExtDeviation4=5;
extern int     ExtBackstep4=3;
extern int     otstup4 = 50;//  High Low       
extern int     lineupw4 = 1;//  
extern color   lineupc4 = LimeGreen;//  
extern int     lineups4 = 1;// 
extern int     linednw4 = 1;//  
extern color   linednc4 = Plum;//  
extern int     linedns4 = 1;// 
extern bool    showrline4 = false;//   
extern string  tlu4 = "i4TrendlineUp";
extern string  tld4 = "i4TrendlineDn";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(ObjectFind(tld1)!=-1) ObjectDelete(tld1);
   if(ObjectFind(tlu1)!=-1) ObjectDelete(tlu1);
   if(ObjectFind(tld2)!=-1) ObjectDelete(tld2);
   if(ObjectFind(tlu2)!=-1) ObjectDelete(tlu2);
   if(ObjectFind(tld3)!=-1) ObjectDelete(tld3);
   if(ObjectFind(tlu3)!=-1) ObjectDelete(tlu3);
   if(ObjectFind(tld4)!=-1) ObjectDelete(tld4);
   if(ObjectFind(tlu4)!=-1) ObjectDelete(tlu4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (useind1) iCustom(Symbol(),i1tf,"fishingind_light",otstup1,lineupw1,lineupc1,lineups1,linednw1,linednc1,linedns1,kolshow1,tlu1,tld1,0,0);
   if (useind2) iCustom(Symbol(),i2tf,"fishingind_light",otstup2,lineupw2,lineupc2,lineups2,linednw2,linednc2,linedns2,kolshow2,tlu2,tld2,0,0);
   if (useind3) iCustom(Symbol(),i3tf,"fishingzz_light",ExtDepth3,ExtDeviation3,ExtBackstep3,otstup3,lineupw3,lineupc3,lineups3,linednw3,linednc3,linedns3,showrline3,tlu3,tld3,0,0);
   if (useind4) iCustom(Symbol(),i4tf,"fishingzz_light",ExtDepth4,ExtDeviation4,ExtBackstep4,otstup4,lineupw4,lineupc4,lineups4,linednw4,linednc4,linedns4,showrline4,tlu4,tld4,0,0);
   return(0);
  }
//+------------------------------------------------------------------+