//+------------------------------------------------------------------+
//|                                                FISHINGIND_V2_03  |
//|              MAX888 && PavelG && Pavka69 && Barrel && UserUserov |
//|             http://forum.tradelikeapro.ru/index.php?topic=4731.0 |
//|                                                          v. 2.03 |
//|     600                                      |
//+------------------------------------------------------------------+

#property copyright "MAX888 && PavelG && Pavka69 && Barrel && UserUserov"
#property link      "http://forum.tradelikeapro.ru/index.php?topic=4731.0"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Silver
//--- input parameters
extern int        otstup = 50;//  High Low       
extern int        lineupw = 1;//  
extern color      lineupc = Blue;//  
extern int        lineups = 1;
extern int        linednw = 1;//  
extern color      linednc = Red;//  
extern int        linedns = 1;
extern int        kolshow = 50; //      
extern string     tlu = "i1TrendlineUp";
extern string     tld = "i1TrendlineDn";


//--- buffers
double High_[];
double Low_[];

bool alert1, alert2;
static int prevtime = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,High_);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,Low_);
   SetIndexEmptyValue(1,0.0);
   SetIndexDrawBegin(0,kolshow);
   SetIndexDrawBegin(1,kolshow);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(ObjectFind(tld)!=-1) ObjectDelete(tld);
   if(ObjectFind(tlu)!=-1) ObjectDelete(tlu);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int count;
   if (Bars <= 4) return (0);
   count = kolshow;
   ArrayInitialize(High_,0.0);
   ArrayInitialize(Low_,0.0);
   
   for (int i = count; i >= 0; i--)
   {
      if(High[i+2]>High[i+1] && High[i+2]>=High[i+3]) High_[i+2] = High[i+2]+Point*otstup;
      if(Low[i+2]<Low[i+1] && Low[i+2]<=Low[i+3]) Low_[i+2] = Low[i+2]-Point*otstup;
   }

   double zzUp1=0,zzUp2=0;   
   double zzDn1=0,zzDn2=0;
   double zz1Up1=0,zz1Up2=0;   
   double zz1Dn1=0,zz1Dn2=0;
   datetime t1Up1, t1Up2, t1Dn1, t1Dn2;
   int iUp1,iUp2,iDn1,iDn2;
   double zzTmp;
   int j=0;
   int prnoedit=0;

   for(i=1;i<=kolshow;i++)
   {
      zzTmp=0;//current
      if(Low_[i]>0) zzTmp=Low_[i];
   
      if(zzTmp>0.0 && j==0 && zzTmp==Low_[i] && zzDn1==0)  {zzDn1=zzTmp; iDn1=i; continue;}
      if(zzDn1!=0) j = 1;
      if(zzTmp>0.0 && zzTmp==Low_[i] && zzDn2==0)  {zzDn2=zzTmp; iDn2=i; continue;}

      if(zzDn1!=0 && zzDn2!=0) break;
   }

   j=0;
   for(i=1;i<=kolshow;i++)
   {
      zzTmp=0;//current
      if(High_[i]>0) zzTmp=High_[i];
   
      if(zzTmp>0.0 && j==0 && zzTmp==High_[i] && zzUp1==0) {zzUp1=zzTmp; iUp1=i; continue;}
      if(zzUp1!=0) j = 1;
      if(zzTmp>0.0 && zzTmp==High_[i] && zzUp2==0) {zzUp2=zzTmp; iUp2=i; continue;}
      if(zzUp1!=0 && zzUp2!=0) break;
   }
   if(zzUp1!=0.0 && zzUp2!=0.0 && zzUp1<=zzUp2)
   {// trend down
      if(ObjectFind(tld)==-1)
       {
         if(ObjectCreate(tld,OBJ_TREND,0,iTime(NULL,0,iUp2),zzUp2,iTime(NULL,0,iUp1),zzUp1))
         {
              ObjectSet(tld,OBJPROP_COLOR,linednc);                
              ObjectSet(tld,OBJPROP_WIDTH,linednw);
              ObjectSet(tld,OBJPROP_STYLE,linedns);
              ObjectSet(tld,OBJPROP_RAY,TRUE);
              alert2 = true;
         }
       }
      else 
      {
         t1Up1 = ObjectGet(tld,OBJPROP_TIME2);
         zz1Up1 = ObjectGet(tld,OBJPROP_PRICE2);
         t1Up2 = ObjectGet(tld,OBJPROP_TIME1);
         zz1Up2 = ObjectGet(tld,OBJPROP_PRICE1);
         if (zz1Up1!=zzUp1 || zz1Up2!=zzUp2 || t1Up1!=iTime(NULL,0,iUp1) || t1Up2 != iTime(NULL,0,iUp2))
         {
            ObjectSet(tld,OBJPROP_TIME1,iTime(NULL,0,iUp2));
            ObjectSet(tld,OBJPROP_PRICE1,zzUp2);
            ObjectSet(tld,OBJPROP_TIME2,iTime(NULL,0,iUp1));
            ObjectSet(tld,OBJPROP_PRICE2,zzUp1);
            alert2 = true;
         }
      }
   }// trend down
   else 
   {
      if(ObjectFind(tld)!=-1) ObjectDelete(tld);
   }

   if(zzDn1!=0.0 && zzDn2!=0.0 && zzDn1>=zzDn2)
   {// trend up
      if(ObjectFind(tlu)==-1)
      {

         if(ObjectCreate(tlu,OBJ_TREND,0,iTime(NULL,0,iDn2),zzDn2,iTime(NULL,0,iDn1),zzDn1))
         {
              ObjectSet(tlu,OBJPROP_COLOR,lineupc);                
              ObjectSet(tlu,OBJPROP_WIDTH,lineupw);
              ObjectSet(tlu,OBJPROP_STYLE,lineups);
              ObjectSet(tlu,OBJPROP_RAY,TRUE);
              alert1 = true;
         }
   
      }
      else 
      {
         t1Dn1 = ObjectGet(tlu,OBJPROP_TIME2);
         zz1Dn1 = ObjectGet(tlu,OBJPROP_PRICE2);
         t1Dn2 = ObjectGet(tlu,OBJPROP_TIME1);
         zz1Dn2 = ObjectGet(tlu,OBJPROP_PRICE1);
         if (zz1Dn1!=zzDn1 || zz1Dn2!=zzDn2 || t1Dn1!=iTime(NULL,0,iDn1) || t1Dn2!=iTime(NULL,0,iDn2))
         {
            ObjectSet(tlu,OBJPROP_TIME1,iTime(NULL,0,iDn2));
            ObjectSet(tlu,OBJPROP_PRICE1,zzDn2);
            ObjectSet(tlu,OBJPROP_TIME2,iTime(NULL,0,iDn1));
            ObjectSet(tlu,OBJPROP_PRICE2,zzDn1);
            alert1 = true;
         }
      }
   }// trend up
   else
   {
      if(ObjectFind(tlu)!=-1) ObjectDelete(tlu);
   }//----
      
//----
   return(0);
}

